---
description: |
    Reference information about the `packer init` command, which downloads and installs one or more plugin binaries specified in a Packer template written in HCL.
page_title: packer init command line reference
---

# `init` command reference

The `packer init` command initializes Packer according to an HCL template configuration. Refer to [Installing Plugins](/packer/docs/plugins/install) for additional information about installing plugins.

## Description

Use the `packer init` command to download and install plugins according to the `required_plugins` block in Packer templates written in HCL. Refer to [Specifying plugin requirements](/packer/docs/templates/hcl_templates/blocks/packer#specifying-plugin-requirements) in the template configuration reference for additional information about configuring the `required_plugins` block.

Legacy JSON templates are not supported. You can convert your JSON template files to HCL using the [hcl2_upgrade](/packer/docs/commands/hcl2_upgrade) command.

We recommend running the `packer init` command as the first step when working with a new or existing template. You can run the command multiple times. Subsequent runs may produce errors, but the command never deletes already-installed plugins.

### Third-party plugin verification

We recommend that you vet and verify any third-party plugins you want to install.

### Installation location

By default, Packer installs plugins into the plugins directory at `$HOME/.config/packer/plugins` on Unix and `%APPDATA%\packer.d\plugins` on Windows, but you can specify a different directory using the `PACKER_PLUGIN_PATH` environment variable. Refer to the [Packer configuration reference](/packer/docs/configure) for additional information.

## Usage
Use the following syntax to run the `packer init` command:

```shell-session
$ packer init <path-to-template> 
```

The template must contain all dependencies when running the command on a single template file. The command fails if the template is intended to be built as a bundle of partials.

## Examples

The following example installs the plugins specified in a template named `template.pkr.hcl`:

```shell-session
$ packer init template.pkr.hcl
```

## Arguments

You can pass the following arguments:

- Packer template: Specify the path to either an HCL2 template or a directory containing at least one valid HCL2 template and related dependencies.


## Options

- `-upgrade`: Use this option to upgrade plugins that are already installed to the latest available version. Packer upgrades to the latest version in accordance with the version constraints specified in the template.
- `-force`: Use this option to force Packer to reinstall plugins.
